import pickle
import logging
from collections import defaultdict
import community
import networkx as nx
import matplotlib.pyplot as plt
from sklearn.metrics import silhouette_score
import numpy as np
import random
logger = logging.getLogger(__name__)
logger.setLevel(logging.DEBUG)
handler = logging.FileHandler("analysis.log")
formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
handler.setFormatter(formatter)
logger.addHandler(handler)



def write_trending_categories_for_clusters_month(month, month_name_to_date_time):
    data = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\data_by_month\normalized_all_months","rb"))
    clusters_with_id = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\results\fwpc\months\clusters-"+month+".pickle","rb"))
    # metadata = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\usermetadata.pickle","rb"))
    # month_name_to_date_time = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\data_by_month\month_name_to_date_time.pickle","rb"))
    emne_to_category_navn = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\emne_to_category_name.pickle","rb"))
    emner = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\emner.pickle","rb"))
    kontoplaner = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\kontoplaner.pickle","rb"))
    fildokumenter = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\fildokumenter.pickle","rb"))
    month_data = data[month_name_to_date_time[month]]

    top_list_all_clusters = dict()
    top_list_of_resources_all_clusters = dict()
    for cluster_key in clusters_with_id.keys():
        users = clusters_with_id[cluster_key]
        cluster_top_dict = defaultdict(float)
        cluster_resource_top_dict = defaultdict(float)
        weight = 1.0 / len(users)
        for user_id in users:
            user_dict = month_data[user_id]
            tuplist = []
            resource_tuplist = []
            category_dict = defaultdict(list)
            resource_dict = defaultdict(float)
            for key in user_dict:

                if key[0] in emne_to_category_navn.keys() and key[1] == 1:
                    if type(emne_to_category_navn[key[0]]) == set:
                        list_of_categories = emne_to_category_navn[key[0]]
                        for category in list_of_categories:
                            category_dict[category].append(user_dict[key])

                    else:
                        category_dict[emne_to_category_navn[key[0]]].append( user_dict[key])
                        if key[0] in emner.keys() and key[1] == 1 :
                            resource_dict['Emne: ' + emner[key[0]]] += user_dict[key]
                        else:

                            resource_dict['slettet'] += user_dict[key]
                if key[1] == 3:
                    category_dict['Kontoplan'].append(user_dict[key])
                    resource_dict["Kontoplan: "+kontoplaner[key[0]]] +=  user_dict[key]
                if key[1] == 2:
                    if key[0] in fildokumenter.keys():
                        category_dict['Fildokument'].append(user_dict[key])
                        resource_dict['Fildokument: ' + fildokumenter[key[0]]] +=   user_dict[key]
                    else:
                        resource_dict['slettet fildokument']+= user_dict[key]

            try:

                tuplist = sorted([(key, np.average(val) ) for key, val in category_dict.items()], key=lambda x: x[1],
                                 reverse=True)

                resource_tuplist = sorted([(key, val) for key, val in resource_dict.items()], key=lambda x: x[1],
                                 reverse=True)

            except ValueError as e:
                pass
            for tup in tuplist:
                # if  tup[1] > 1: print(tup)

                cluster_top_dict[tup[0]] += tup[1]  * weight

            for tup in resource_tuplist:
                cluster_resource_top_dict[tup[0]] += np.average(tup[1]) * weight


        # print(max(values))
        top_list =sorted(list(cluster_top_dict.items()), key = lambda x: x[1], reverse= True)
        top_list_of_resources =sorted(list(cluster_resource_top_dict.items()), key = lambda x: x[1], reverse= True)
        num = max(top_list, key= lambda x:x[1])
        if num[1] >1: print (num)
        # max_resource_top_list = max(top_list_of_resources, key = lambda x: x[1])[1]
        # max_top_list = max(top_list, key = lambda x: x[1])[1]
        # top_list = list(map(lambda x: (x[0],x[1]/max_top_list), top_list))
        # top_list_of_resources = list(list(map(lambda x: (x[0],x[1]/max_resource_top_list), top_list_of_resources)))
        top_list_of_resources_all_clusters[cluster_key] = top_list_of_resources
        top_list_all_clusters[cluster_key] = top_list
    cluster_data = dict()
    # for cluster_key in clusters_with_id.keys():
    #     cluster_user_data = dict()
    #     cluster = clusters_with_id[cluster_key]
    #     total_users_with_data = 0
    #     total_users = 0
    #     for user in cluster:
    #         total_users += 1
    #         if user in metadata.keys():
    #             total_users_with_data += 1
    #             userdict = metadata[user]
    #             for data_key in userdict.keys():
    #
    #                 if userdict[data_key] != "":
    #                     if data_key in cluster_user_data.keys():
    #                         if type(userdict[data_key]) == list:
    #                             cluster_user_data[data_key].extend(userdict[data_key])
    #                         else:
    #                             cluster_user_data[data_key].append(userdict[data_key])
    #                     else:
    #                         if type(userdict[data_key]) == list:
    #                             cluster_user_data[data_key] = list(userdict[data_key])
    #                         else:
    #                             cluster_user_data[data_key] = [userdict[data_key]]
    #
    #     count_dict = dict()
    #     for key in cluster_user_data.keys():
    #         vals = set(cluster_user_data[key])
    #         if key.lower() == "bransje": vals = ["Regnskapsbyrå", "Revisjonsselskap", "Other"]
    #         temp_dict = dict()
    #         for val in vals:
    #             if val != "Other": temp_dict[val] = cluster_user_data[key].count(val)
    #             else:
    #                 regnskap =  cluster_user_data[key].count("Regnskapsbyrå")
    #                 revisjon =  cluster_user_data[key].count("Revisjonsselskap")
    #                 temp_dict[val] = len(cluster_user_data[key]) - regnskap -revisjon
    #         total = sum(temp_dict.values())
    #         for value_key in temp_dict.keys():
    #             # temp_dict[value_key] = math.ceil((temp_dict[value_key]/total)*100)
    #             temp_dict[value_key] = '{0:.3g}'.format((temp_dict[value_key] / total_users_with_data) * 100)
    #         count_dict[key] = temp_dict
    #     cluster_data[cluster_key] = (count_dict, total_users_with_data, total_users)


    with open(r"C:\Users\Student\PycharmProjects\masteroppgave\analysis\-"+month+".txt", "wb") as handle:
        count = 0
        out = "Discovered a total of " + str(len(list(clusters_with_id.keys()))) +" clusters: \n"
        for cluster in clusters_with_id.keys():
            members = len(clusters_with_id[cluster])
            count += 1
            out += "Cluster number " + str(count) + ":  \nNumber of users in this cluster: " + str(members) + "\n"
            out += "============================================\n"
            top_list = top_list_all_clusters[cluster]
            resource_top_list = top_list_of_resources_all_clusters[cluster]
            for val in top_list[:10]:
                out += str(val[0]) + ";" + str(val[1]) +"\n"
            out += "\n \n \n"
            for resource_val in resource_top_list[:20]:
                out += str(resource_val[0]) + ";" + str(resource_val[1]) + "\n"
            # data_dict,num_meta, num_total =  cluster_data[cluster]
            #
            # out += "Metadata: \n"
            # out += "Number of users for which we have metadata: " + str(num_meta) + "\n"
            # for key in ["stilling","bransje"]:
            #     out += str(key).upper() + ":\n"
            #     try:
            #         sorted_values = sorted(list(zip(data_dict[key].keys(), data_dict[key].values())),
            #                                key=lambda x: float(x[1]), reverse=True)
            #     except KeyError as e:
            #         if num_meta == 0:
            #             logger.error("No metadata")
            #
            #     for val in sorted_values:
            #         out += str(val[0]) + ";" + str(val[1]) + "\n"
            out += "\n \n \n"
        handle.write(out.encode("utf8"))


def write_trending_categories_for_clusters_month_removing_averages(month, month_name_to_date_time):
    data = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\data_by_month\normalized_all_months","rb"))
    clusters_with_id = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\results\fwpc\months\clusters-"+month+".pickle","rb"))
    # metadata = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\usermetadata.pickle","rb"))
    # month_name_to_date_time = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\data_by_month\month_name_to_date_time.pickle","rb"))
    emne_to_category_navn = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\emne_to_category_name.pickle","rb"))
    emner = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\emner.pickle","rb"))
    kontoplaner = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\kontoplaner.pickle","rb"))
    fildokumenter = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\fildokumenter.pickle","rb"))
    month_data = data[month_name_to_date_time[month]]

    top_list_all_clusters = dict()
    top_list_of_resources_all_clusters = dict()
    for cluster_key in clusters_with_id.keys():
        users = clusters_with_id[cluster_key]
        cluster_top_dict = defaultdict(float)
        cluster_resource_top_dict = defaultdict(float)
        weight = 1.0 / len(users)
        for user_id in users:
            cluster_top_list = month_data[user_id]
            tuplist = []
            resource_tuplist = []
            category_dict = defaultdict(list)
            resource_dict = defaultdict(float)
            for key in cluster_top_list:

                if key[0] in emne_to_category_navn.keys() and key[1] == 1:
                    if type(emne_to_category_navn[key[0]]) == set:
                        list_of_categories = emne_to_category_navn[key[0]]
                        for category in list_of_categories:
                            category_dict[category].append(cluster_top_list[key])

                    else:
                        category_dict[emne_to_category_navn[key[0]]].append( cluster_top_list[key])
                        if key[0] in emner.keys() and key[1] == 1 :
                            resource_dict['Emne: ' + emner[key[0]]] += cluster_top_list[key]
                        else:

                            resource_dict['slettet'] += cluster_top_list[key]
                if key[1] == 3:
                    category_dict['Kontoplan'].append(cluster_top_list[key])
                    resource_dict["Kontoplan: "+kontoplaner[key[0]]] +=  cluster_top_list[key]
                if key[1] == 2:
                    if key[0] in fildokumenter.keys():
                        category_dict['Fildokument'].append(cluster_top_list[key])
                        resource_dict['Fildokument: ' + fildokumenter[key[0]]] +=   cluster_top_list[key]
                    else:
                        resource_dict['slettet fildokument']+= cluster_top_list[key]

            try:

                tuplist = sorted([(key, np.average(val) ) for key, val in category_dict.items()], key=lambda x: x[1],
                                 reverse=True)

                resource_tuplist = sorted([(key, val) for key, val in resource_dict.items()], key=lambda x: x[1],
                                 reverse=True)

            except ValueError as e:
                pass
            for tup in tuplist:
                # if  tup[1] > 1: print(tup)

                cluster_top_dict[tup[0]] += tup[1]  * weight

            for tup in resource_tuplist:
                cluster_resource_top_dict[tup[0]] += np.average(tup[1]) * weight


        # print(max(values))

        # max_resource_top_list = max(top_list_of_resources, key = lambda x: x[1])[1]
        # max_top_list = max(top_list, key = lambda x: x[1])[1]
        # top_list = list(map(lambda x: (x[0],x[1]/max_top_list), top_list))
        # top_list_of_resources = list(list(map(lambda x: (x[0],x[1]/max_resource_top_list), top_list_of_resources)))
        top_list_of_resources_all_clusters[cluster_key] = cluster_resource_top_dict.items()
        top_list_all_clusters[cluster_key] = cluster_top_dict.items()
    # cluster_data = dict()
    # for cluster_key in clusters_with_id.keys():
    #     cluster_user_data = dict()
    #     cluster = clusters_with_id[cluster_key]
    #     total_users_with_data = 0
    #     total_users = 0
    #     for user in cluster:
    #         total_users += 1
    #         if user in metadata.keys():
    #             total_users_with_data += 1
    #             userdict = metadata[user]
    #             for data_key in userdict.keys():
    #
    #                 if userdict[data_key] != "":
    #                     if data_key in cluster_user_data.keys():
    #                         if type(userdict[data_key]) == list:
    #                             cluster_user_data[data_key].extend(userdict[data_key])
    #                         else:
    #                             cluster_user_data[data_key].append(userdict[data_key])
    #                     else:
    #                         if type(userdict[data_key]) == list:
    #                             cluster_user_data[data_key] = list(userdict[data_key])
    #                         else:
    #                             cluster_user_data[data_key] = [userdict[data_key]]
    #
    #     count_dict = dict()
    #     for key in cluster_user_data.keys():
    #         vals = set(cluster_user_data[key])
    #         if key.lower() == "bransje": vals = ["Regnskapsbyrå", "Revisjonsselskap", "Other"]
    #         temp_dict = dict()
    #         for val in vals:
    #             if val != "Other": temp_dict[val] = cluster_user_data[key].count(val)
    #             else:
    #                 regnskap =  cluster_user_data[key].count("Regnskapsbyrå")
    #                 revisjon =  cluster_user_data[key].count("Revisjonsselskap")
    #                 temp_dict[val] = len(cluster_user_data[key]) - regnskap -revisjon
    #         total = sum(temp_dict.values())
    #         for value_key in temp_dict.keys():
    #             # temp_dict[value_key] = math.ceil((temp_dict[value_key]/total)*100)
    #             temp_dict[value_key] = '{0:.3g}'.format((temp_dict[value_key] / total_users_with_data) * 100)
    #         count_dict[key] = temp_dict
    #     cluster_data[cluster_key] = (count_dict, total_users_with_data, total_users)
    averages_resources = defaultdict(list)
    averages_categories = defaultdict(list)
    for cluster_top_list in top_list_of_resources_all_clusters.values():
        for resource in cluster_top_list:
            averages_resources[resource[0]].append(resource[1])
    averages_categories = defaultdict(list)
    for cluster_top_list in  top_list_all_clusters.values():
        for resource in cluster_top_list:
            averages_categories[resource[0]].append(resource[1])

    averages_resources = {key: np.average(val) for key, val in averages_resources.items()}

    averages_categories = {key:np.average(val) for key, val in averages_categories.items()}
    for key, val in top_list_of_resources_all_clusters.items():
        val = sorted(val,key =lambda x:x[1] - averages_resources[x[0]], reverse = True)
        top_list_of_resources_all_clusters[key] = list(val)
    for key, val in top_list_all_clusters.items():
        val = sorted(val,key =lambda x:x[1] - averages_categories[x[0]], reverse = True)
        top_list_all_clusters[key] = list(val)



    with open(r"C:\Users\Student\PycharmProjects\masteroppgave\analysis\-"+month+"avg-removed.txt", "wb") as handle:
        count = 0
        out = "Discovered a total of " + str(len(list(clusters_with_id.keys()))) +" clusters: \n"
        for cluster in clusters_with_id.keys():
            members = len(clusters_with_id[cluster])
            count += 1
            out += "Cluster number " + str(count) + ":  \nNumber of users in this cluster: " + str(members) + "\n"
            out += "============================================\n"
            top_list = top_list_all_clusters[cluster]
            resource_top_list = top_list_of_resources_all_clusters[cluster]

            for val in list(top_list)[:10]:
                out += str(val[0]) + ";" + str(val[1]) +"\n"
            out += "\n \n \n"
            for resource_val in resource_top_list[:20]:
                out += str(resource_val[0]) + ";" + str(resource_val[1]) + "\n"
            # data_dict,num_meta, num_total =  cluster_data[cluster]
            #
            # out += "Metadata: \n"
            # out += "Number of users for which we have metadata: " + str(num_meta) + "\n"
            # for key in ["stilling","bransje"]:
            #     out += str(key).upper() + ":\n"
            #     try:
            #         sorted_values = sorted(list(zip(data_dict[key].keys(), data_dict[key].values())),
            #                                key=lambda x: float(x[1]), reverse=True)
            #     except KeyError as e:
            #         if num_meta == 0:
            #             logger.error("No metadata")
            #
            #     for val in sorted_values:
            #         out += str(val[0]) + ";" + str(val[1]) + "\n"
            out += "\n \n \n"
        handle.write(out.encode("utf8"))


def compare_two_months(month1_name, month2_name):
    month1 = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\results\fwpc\months\clusters-" + month1_name + ".pickle", "rb"))
    month2 = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\results\fwpc\months\clusters-" + month2_name + ".pickle", "rb"))
    month1_keys = list(month1.keys())
    month2_keys = list(month2.keys())
    sims = np.zeros((len(month1_keys), len(month2_keys)),dtype=int)
    for i in range (len(month1_keys)):
        for j in range(len(month2_keys)):
            i_val = set(month1[month1_keys[i]])
            j_val= set(month2[month2_keys[j]])
            sim = len(i_val.intersection(j_val))
            sims[i][j] = sim
    print(sims)



month_name_to_date_time = pickle.load(
    open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\data_by_month\month_name_to_date_time.pickle", "rb"))

write_trending_categories_for_clusters_month('May2015', month_name_to_date_time)

# cluster_path = r"C:\Users\Student\PycharmProjects\masteroppgave\results\fwpc\months\clusters-June2016.pickle"
# conns_path = r"C:\Users\Student\PycharmProjects\masteroppgave\results\fwpc\months\connections-June2016.pickle"
# keys_path = r"C:\Users\Student\PycharmProjects\masteroppgave\results\fwpc\months\keys-June2016.pickle"
# clusters = pickle.load(open(cluster_path,"rb"))
# conns = pickle.load(open(conns_path,"rb"))
# keys = pickle.load(open(keys_path,"rb"))
# labels =[]
# id_to_cluster = dict()
# for cluster, members in clusters.items():
#     for member in members:
#         id_to_cluster[member] = cluster
# for key in keys:
#     labels.append(id_to_cluster.get(key[0],-1))
#
#
# randshape = np.shape(conns)
# randommat = np.random.rand(randshape[0],randshape[1])
# G = nx.from_numpy_matrix(randommat)
# best = community.best_partition(G)
# labels = best.values()
# print(labels)

# month = 'June2015'
# month_name_to_date_time = pickle.load(
#     open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\data_by_month\month_name_to_date_time.pickle", "rb"))
# # compare_two_months('January2016','January2017')
# write_trending_categories_for_clusters_month(month,month_name_to_date_time)

# for month_name in month_name_to_date_time.keys():
#     write_trending_categories_for_clusters_month(month_name, month_name_to_date_time)
#     print('success')
# write_trending_categories_for_clusters_month('January2016', month_name_to_date_time)