import pickle
import pyodbc
import time
import json
import datetime
import uuid
import numpy as np
import matplotlib.pyplot as plt
from queries import SQL_GET_EVENTS, SQL_kategori_item, SQL_kategori, SQL_fagomrade, SQL_fagomrade_item, SQL_GET_EMNE,\
    SQL_GET_FILDOKUMENT, SQL_GET_KONTOPLAN
from dateutil.relativedelta import relativedelta

def establish_db_connection():
    connection_in = pyodbc.connect(r'DSN=studentdsn; Trusted_Connection=yes;')
    return connection_in

def import_data_log_indexed_on_user():
    total = 0
    data_log_indexed_on_user_id = dict()
    conn = establish_db_connection()
    cursor = conn.cursor()
    cursor.execute(SQL_GET_EVENTS)
    results = cursor.fetchone()
    while results:
        total += 1
        user_id, type_id, subject_id, tidspunkt = results
        if user_id in data_log_indexed_on_user_id.keys():
            data_log_indexed_on_user_id[user_id].append((tidspunkt, (subject_id, type_id)))
        else:
            data_log_indexed_on_user_id[user_id] = [(tidspunkt, (subject_id, type_id))]
        results = cursor.fetchone()
    for key in data_log_indexed_on_user_id.keys():
        data_log_indexed_on_user_id[key]  = sorted(data_log_indexed_on_user_id[key], key=lambda x:x[0])
        print(len(list(data_log_indexed_on_user_id[key])))
    print(total)
    pickle.dump(data_log_indexed_on_user_id, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\data_log_index_on_user_id.pickle","wb"))


def convert_data_log_indexed_on_user_to_hit_dict(data):
    hit_dict = dict()
    for key in data.keys():
        for element in data[key]:
            composite_key = element[1]
            if key in hit_dict.keys():
                if composite_key in hit_dict[key].keys():
                    hit_dict[key][composite_key] += 1
                else:
                    hit_dict[key][composite_key] = 1
            else:
                hit_dict[key] = {composite_key: 1}
    pickle.dump(hit_dict, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\hit_dict_index_on_user_id.pickle","wb"))

def generate_week_sessions(data):
    # 13.april.2015 first monday
    # 5.mars.2017 last sunday
    week = datetime.timedelta(days=7)
    weeks = []
    caret = datetime.datetime(2015,4,6)
    dict_of_all_user_week_dicts = dict()
    while caret < datetime.datetime(2017,3,12):
        start = caret
        end = caret + week
        weeks.append((start,end))
        caret += week
    def check_if_date_in_week(date_ob, week):
        in_week = False
        if week[0] < date_ob < week[1]:
            in_week = True
        return in_week


    #First each user must have a dictionary of hits indexed on week start and end
    for user_key in data.keys():
        user_week_dict = dict()
        user_log = data[user_key]
        user_week_index = 0
        current = weeks[user_week_index]
        for element in user_log:
            if datetime.datetime(2015,4,6)<element[0 ]< datetime.datetime(2017,3,12):
                date_ob, comp_key = element
                while not check_if_date_in_week(date_ob, current):
                    user_week_index += 1
                    current = weeks[user_week_index]
                if current in user_week_dict.keys():
                    if comp_key in user_week_dict[current].keys():
                        user_week_dict[current][comp_key] += 1
                    else:
                        user_week_dict[current][comp_key] = 1
                else:
                    user_week_dict[current] = {comp_key: 1}
            else:
                print(element[0])
        for key in user_week_dict:
            dict_of_all_user_week_dicts[user_key] = user_week_dict
    #then the weeks are added to a dictionary containing {week_id: {sub_key: count, other_sub_key: count}}
    week_id = 0
    week_dict = dict()
    user_id_to_week_id = dict()
    week_id_to_user_id = dict()
    for user_key in dict_of_all_user_week_dicts.keys():
        for week_key in dict_of_all_user_week_dicts[user_key].keys():
            # print(dict_of_all_user_week_dicts[user_key][week_key])
            week_dict[week_id] = dict_of_all_user_week_dicts[user_key][week_key]
            week_id_to_user_id[week_id] = user_key
            if user_key in user_id_to_week_id.keys():
                user_id_to_week_id[user_key].append(week_id)
            else:
                user_id_to_week_id[user_key] = [week_id]
            week_id += 1

    pickle.dump(dict_of_all_user_week_dicts, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\dict_of_all_user_week_dicts.pickle","wb"))
    pickle.dump(week_dict, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\week_dict.pickle","wb"))
    pickle.dump(user_id_to_week_id,open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\user_id_to_week_id.pickle","wb"))
    pickle.dump(week_id_to_user_id,
                open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\week_id_to_user_id.pickle", "wb"))

def generate_month_sessions(data):
    # 13.april.2015 first monday
    # 5.mars.2017 last sunday

    weeks = []
    caret = datetime.datetime(2015,4,1)
    dict_of_all_user_week_dicts = dict()
    while caret < datetime.datetime(2017,3,31):
        start = caret
        end = caret + relativedelta(months=+1)
        weeks.append((start,end))
        caret += relativedelta(months=+1)
    def check_if_date_in_week(date_ob, week):
        in_week = False
        if week[0] < date_ob < week[1]:
            in_week = True
        return in_week


    #First each user must have a dictionary of hits indexed on week start and end
    for user_key in data.keys():
        user_week_dict = dict()
        user_log = data[user_key]
        user_week_index = 0
        current = weeks[user_week_index]
        for element in user_log:
            if datetime.datetime(2015,4,6)<element[0 ]< datetime.datetime(2017,3,12):
                date_ob, comp_key = element
                while not check_if_date_in_week(date_ob, current):
                    user_week_index += 1

                    current = weeks[user_week_index]
                if current in user_week_dict.keys():
                    if comp_key in user_week_dict[current].keys():
                        user_week_dict[current][comp_key] += 1
                    else:
                        user_week_dict[current][comp_key] = 1
                else:
                    user_week_dict[current] = {comp_key: 1}
            else:
                print(element[0])
        for key in user_week_dict:
            dict_of_all_user_week_dicts[user_key] = user_week_dict
    #then the weeks are added to a dictionary containing {week_id: {sub_key: count, other_sub_key: count}}
    week_id = 0
    week_dict = dict()
    user_id_to_week_id = dict()
    week_id_to_user_id = dict()
    for user_key in dict_of_all_user_week_dicts.keys():
        for week_key in dict_of_all_user_week_dicts[user_key].keys():
            # print(dict_of_all_user_week_dicts[user_key][week_key])
            week_dict[week_id] = dict_of_all_user_week_dicts[user_key][week_key]
            week_id_to_user_id[week_id] = user_key
            if user_key in user_id_to_week_id.keys():
                user_id_to_week_id[user_key].append(week_id)
            else:
                user_id_to_week_id[user_key] = [week_id]
            week_id += 1

    pickle.dump(dict_of_all_user_week_dicts, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\dict_of_all_user_month_dicts.pickle","wb"))
    pickle.dump(week_dict, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\month_dict.pickle","wb"))
    pickle.dump(user_id_to_week_id,open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\user_id_to_month_id.pickle","wb"))
    pickle.dump(week_id_to_user_id,
                open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\month_id_to_user_id.pickle", "wb"))




def normalize_dict(hit_dict):

    normalized_dict = dict()
    for key in hit_dict.keys():
        normalized_dict[key] = dict()
        temp_dict = hit_dict[key]
        max_val = float(max(temp_dict.values()))
        min_val = 0
        for hit_key in temp_dict.keys():
            try:
                val = (temp_dict[hit_key] - min_val) / (max_val-min_val)
                normalized_dict[key][hit_key] = val
            except ZeroDivisionError:
                #If zero division error, max val = min val(only one item is visited)
                normalized_dict[key][hit_key] = 1
    return normalized_dict


def import_user_info_from_json():
    user_info_dict = dict()
    with open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\userdata.csv", "r") as handle:
        handle.readline()
        data = handle.readline()

        while data:
            id, info = data.split(";")
            id = int(id)
            info = info[1:-2]
            info = info.replace('""', '"')

            try:
                data_dict = json.loads(info)
                print(data_dict)
                user_info_dict[id] = data_dict
            except json.JSONDecodeError:
                pass

            data = handle.readline()
    pickle.dump(user_info_dict, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\usermetadata.pickle", "wb"))

def import_and_save_kategori_emne_to_category_name_dict():
    emne_conn = pyodbc.connect(r'DSN=studentdsn; Trusted_Connection=yes;')
    cursor = emne_conn.cursor()
    cursor.execute(SQL_kategori)
    results = cursor.fetchone()
    emne_dict = dict()
    while results:
        id, tittel = results
        emne_dict[id] = tittel
        results = cursor.fetchone()
    emne_name_dict = dict()
    print(emne_dict)
    cursor.execute(SQL_kategori_item)
    results = cursor.fetchone()
    while results:
        emne, id = results
        emne_name_dict[emne] = emne_dict[id]
        results = cursor.fetchone()
    pickle.dump(emne_name_dict,open (r"C:\Users\Student\PycharmProjects\masteroppgave\data\emne_to_category_name.pickle","wb"))

def import_and_save_kategori_emne_to_fagomrade_name_dict():
    fagomrade_conn = pyodbc.connect(r'DSN=studentdsn; Trusted_Connection=yes;')
    cursor = fagomrade_conn.cursor()
    cursor.execute(SQL_fagomrade)
    results = cursor.fetchone()
    fagomrade_dict = dict()
    while results:
        id, tittel = results
        fagomrade_dict[id] = tittel
        results = cursor.fetchone()
    fagomrade_name_dict = dict()
    print(fagomrade_dict)
    cursor.execute(SQL_fagomrade_item)
    results = cursor.fetchone()
    while results:
        emne, id = results
        fagomrade_name_dict[emne] = fagomrade_dict[id]
        results = cursor.fetchone()
    pickle.dump(fagomrade_name_dict,
                open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\emne_to_fagomrade_name.pickle","wb"))
def import_all_emner():
    fagomrade_conn = pyodbc.connect(r'DSN=studentdsn; Trusted_Connection=yes;')
    cursor = fagomrade_conn.cursor()
    cursor.execute(SQL_GET_EMNE)
    results = cursor.fetchone()
    emne_dict = dict()
    while results:
        id, tittel = results
        emne_dict[id] = tittel
        results = cursor.fetchone()
    pickle.dump(emne_dict, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\emner.pickle","wb"))
def import_all_fildokument():
    fagomrade_conn = pyodbc.connect(r'DSN=studentdsn; Trusted_Connection=yes;')
    cursor = fagomrade_conn.cursor()
    cursor.execute(SQL_GET_FILDOKUMENT)
    results = cursor.fetchone()
    emne_dict = dict()
    while results:
        id, tittel = results
        emne_dict[id] = tittel
        results = cursor.fetchone()
    pickle.dump(emne_dict, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\fildokumenter.pickle","wb"))


def import_all_kontoplan():
    fagomrade_conn = pyodbc.connect(r'DSN=studentdsn; Trusted_Connection=yes;')
    cursor = fagomrade_conn.cursor()
    cursor.execute(SQL_GET_KONTOPLAN)
    results = cursor.fetchone()
    emne_dict = dict()
    while results:
        id, tittel = results
        emne_dict[id] = tittel
        results = cursor.fetchone()
    pickle.dump(emne_dict, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\kontoplaner.pickle","wb"))
# import_user_info_from_json()
# import_all_fildokument()
# import_all_kontoplan()
# import_data_log_indexed_on_user()
# other_data = pickle.load (open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\data_log_index_on_user_id.pickle", "rb"))
# generate_month_sessions(other_data)
# data_by_month = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\month_dict.pickle","rb"))

# data_by_user = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\hit_dict_index_on_user_id.pickle","rb"))

#
# normalized_month_hit_dict = normalize_dict(data_by_month)
# normalized_user_hit_dict = normalize_dict(data_by_user)
# pickle.dump(normalized_user_hit_dict, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\normalized_hit_dict_index_on_user_id.pickle","wb"))
# pickle.dump(normalized_month_hit_dict, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\normalized_hit_dict_index_on_month_id.pickle","wb"))

# convert_data_log_indexed_on_user_to_hit_dict(other_data)
# pickle.dump(user_to_id,open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\user_to_week_id.pickle","wb"))
# pickle.dump(id_to_week,open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\week_id_to_week_date_and_vector.pickle","wb"))
# id_to_week = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\week_id_to_week_date_and_vector.pickle","rb"))
# user_to_id = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\user_to_week_id.pickle","rb"))
#
# months = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\dict_of_all_user_month_dicts.pickle","rb"))
#
#
#
#
all_months = dict()
#
# for user in months.keys():
#     monthly_by_user = months[user]
#     for month in monthly_by_user.keys():
#         if month in all_months.keys():
#             all_months[month][user] = monthly_by_user[month]
#         else:
#             all_months[month]  = {user:monthly_by_user[month]}
#
#
#
normalized_month_dict = {}
for month in all_months.keys():
    month_dict = all_months[month]
    normalized = normalize_dict(month_dict)
    normalized_month_dict[month] = normalized_month_dict
for month in normalized_month_dict.keys():
    print(month, normalized_month_dict[month].values())
#
#
#
# pickle.dump(all_months, open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\data_by_month\normalized_all_months","wb"))
#
#

# id_to_week = pickle.load(open(r"C:\Users\Student\PycharmProjects\masteroppgave\data\month_dict.pickle","rb"))

# #
# id_to_user = dict()
# active_users = set()
# week_usage_freqs = []
# week_usage_distinct = []
# total = 0
# for key in id_to_week.keys():
#     freq = sum(id_to_week[key].values())
#     distinct = len(list(id_to_week[key].keys()))
#     week_usage_freqs.append(freq)
#     week_usage_distinct.append(distinct)
#     if freq > 13 and distinct > 17:
#         total += 1
#
#
# # #
# week_usage_distinct.sort()
# week_usage_freqs.sort()
#
# # print(sum(week_usage_freqs))
# # weeks = 0
#
# print(np.percentile(week_usage_distinct,[10,20,30,40,50,60,70,80,90,100]))
# print(list(map(lambda x: int(x),np.percentile(week_usage_freqs,[10,20,30,40,50,60,70,80,90,100]))))
# print("total sessions over 70th percentile: ", str(total))